
#include "sevenseg_display_drv.h"
#include <TimeLib.h>  

sevenseg_display_drv display7seg;

void setup()
{
	display7seg.init();//Initiate displays
	display7seg.begin_drv();//Run interupt
	display7seg.set_brightness(0);
	setTime(10, 10, 0, 1, 1, 2017);
	pinMode(A5, INPUT);
}

void loop()
{
	uint8_t mode = 5;
	double sensorValue;
	float voltage;
	//display7seg.set_dp(0);
	//display7seg.reset_dp(1);
	//display7seg.reset_dp(2);
	//display7seg.reset_dp(3);

	switch (mode) {
	case 0://Counter mode
		for (uint8_t m = 0; m < 10; m++) {
			for (uint8_t i = 0; i < 10; i++) {
				for (uint8_t j = 0; j < 10; j++) {
					for (uint8_t k = 0; k < 10; k++) {
						display7seg.set_digit(0, k);
						display7seg.set_digit(1, j);
						display7seg.set_digit(2, i);
						display7seg.set_digit(3, m);
						delay(1);
					}
				}
			}
		}
		break;
	case 1://Clock mode
		display7seg.set_digit(0, minute()%10);
		display7seg.set_digit(1, minute()/10);
		display7seg.set_digit(2, hour()%10);
		display7seg.set_digit(3, hour()/10);
		if (millis()%1000 > 500) display7seg.set_colon();
		else display7seg.reset_colon();
		break;
	case 2://Display mode
		print_num(3456);
		delay(1000);
		print_num(345);
		delay(1000);
		print_num(34);
		delay(1000);
		print_num(3);
		delay(1000);
		print_num(3.141);
		delay(1000);
		print_num(3.1415);
		delay(1000);
		print_num(3.14);
		delay(1000);
		print_num(3.1);
		delay(1000);
		print_num(0);
		delay(1000);
		print_num(0.0);
		delay(1000);
		print_num(0.01);
		delay(1000);
		print_num(0.001);
		delay(1000);
		print_num(0.0001);
		delay(1000);
		break;
	case 3:
		sensorValue = 0;
		for (int i = 0; i < 2000; i++) sensorValue += analogRead(A5);

		voltage = (sensorValue/ 2000) * (5.0 / 1023.0);
		print_num(voltage);
		//delay(500);
		break;
	case 4://Display mode
		print_num(1);
		delay(1000);
		print_num1(0);
		delay(1000);

		print_num(2);
		delay(1000);
		print_num1(0.1);
		delay(1000);

		print_num(3);
		delay(1000);
		print_num1(0.01);
		delay(1000);

		print_num(4);
		delay(1000);
		print_num1(0.001);
		delay(1000);

		print_num(5);
		delay(1000);
		print_num1(0.0001);
		delay(1000);
		break;
	case 5://Temperature mode
		display7seg.set_digit(0, 1);
		display7seg.set_digit(1, 5);
		display7seg.set_digit(2, 2);
		display7seg.set_apostrophe();
		delay(1000);
		break;
	default:
		break;
	}

	
	
	
}

void print_num1(double floatnum) {
	int fourdigits;
	int dig_num = log10(floatnum) + 1;
	if (dig_num >= 0) fourdigits = round(floatnum*pow(10, 4 - dig_num));
	else fourdigits = round(floatnum*pow(10, 4 - dig_num));//?
	char tempString[10];
	sprintf(tempString, "%4d", fourdigits);

	display7seg.reset_dp(0);
	display7seg.reset_dp(1);
	display7seg.reset_dp(2);
	display7seg.reset_dp(3);

	display7seg.set_digit(0, dig_num);

	//display7seg.set_digit(0, (uint8_t)(tempString[3] - '0'));
	//display7seg.set_digit(1, (uint8_t)(tempString[2] - '0'));
	//display7seg.set_digit(2, (uint8_t)(tempString[1] - '0'));
	//display7seg.set_digit(3, (uint8_t)(tempString[0] - '0'));
	//display7seg.set_dp(4 - dig_num);
}

void print_num(double floatnum) {
	char tempString[5];
	int fourdigits;

	display7seg.reset_dp(0);
	display7seg.reset_dp(1);
	display7seg.reset_dp(2);
	display7seg.reset_dp(3);
	
	int dig_num = log10(floatnum) + 1;
	if (dig_num >= 0) {
		fourdigits = round(floatnum*pow(10, 4 - dig_num));
		if (fourdigits==0) sprintf(tempString, "%4s", "0000");
		else sprintf(tempString, "%4d", fourdigits);
		display7seg.set_digit(0, (uint8_t)(tempString[3] - '0'));
		display7seg.set_digit(1, (uint8_t)(tempString[2] - '0'));
		display7seg.set_digit(2, (uint8_t)(tempString[1] - '0'));
		display7seg.set_digit(3, (uint8_t)(tempString[0] - '0'));
		display7seg.set_dp(4 - dig_num);
	}
	else {
		fourdigits = round(floatnum*10000);
		sprintf(tempString, "%4d", fourdigits);
		display7seg.set_digit(0, fourdigits % 10 );
		display7seg.set_digit(1, fourdigits /10 %10);
		display7seg.set_digit(2, (fourdigits /100 % 10));
		display7seg.set_digit(3, 0);
		display7seg.set_dp(3);
	}

	
	
	
}

//http://forum.arduino.cc/index.php?topic=44262.0
char *ftoa(char *a, double f, int precision)
{
	long p[] = { 0,10,100,1000,10000,100000,1000000,10000000,100000000 };

	char *ret = a;
	long heiltal = (long)f;
	itoa(heiltal, a, 10);
	while (*a != '\0') a++;
	*a++ = '.';
	long desimal = abs((long)((f - heiltal) * p[precision]));
	itoa(desimal, a, 10);
	return ret;
}