//Used information:
//http://www.allaboutcircuits.com/projects/interface-a-seven-segment-display-to-an-arduino/
//http://skpang.co.uk/blog/archives/323



#ifndef _SEVENSEG_DISPLAY_DRV_h
#define _SEVENSEG_DISPLAY_DRV_h

#if defined(ARDUINO) && ARDUINO >= 100
	#include "arduino.h"
#else
	#include "WProgram.h"
	#include "pins_arduino.h"
#endif

//This is for Model No.: YSD-439AK2B-35
//Avialable from Sparkfun https://www.sparkfun.com/products/9482
//Should work also for any common anode 7 segment display
//Connection to Arduino Uno as:
//a-0, b-1,c-2,d-3,e-4,f-5,g-6,7-dp
//8 -dig4,9-dig3,10-dig2,11-dig1,12 - col,13 - apos
const unsigned char PROGMEM bcd[10] = {
	0xC0, //0
	0xF9, //1
	0xA4, //2
	0xB0, //3
	0x99, //4
	0x92, //5
	0x82, //6
	0xF8, //7
	0x80, //8
	0x90 //9
};

class sevenseg_display_drv
{
public:
	sevenseg_display_drv();
	void begin_drv();
	void updateDisplay();
	uint8_t init();
	void set_digit( uint8_t dig_num, uint8_t value);
	void set_brightness(uint8_t brightness);
	void set_dp(uint8_t dig_num );
	void reset_dp(uint8_t dig_num);
	void set_colon();
	void reset_colon();
	void set_apostrophe();
	void reset_apostrophe();
private:
	uint8_t         *displaybuff, digitmap[4],dp_buffer[4],colon_and_ap;//Supports up to 2 4 digit 7 segment modules
	volatile uint8_t pwm_count,brightness, digit_num,display_num, pwm_count_max, *display_port[2];
	uint8_t buffsize, display_size[2];
};

#endif